LArSoft - Bug #22368

Cannot do mrbsetenv on OSX with icarus_data
04/12/2019 11:16 AM - Tracy Usher

Status: Closed Start date: 04/12/2019
Priority: High Due date:

Assignee: % Done: 100%
Category: Estimated time: 0.00 hour
Target version: Spent time: 4.00 hours
Occurs In: develop/HEAD Co-Assignees:

Experiment: ICARUS

Description

The icarus_data package is, well, a package of various data files... probably it is outdated in the sense that there are meant to be
better ways to address the problem it is solving, but it should still be possible to do a setup... As near as | can tell, the problem is that
icarus_data itself has no qualifiers AND it doesn't depend on anything. Somehow the following lines in the product_deps file do not
get properly parsed on OSX when doing "mrbsetenv":

# We now define allowed qualifiers and the corresponding qualifiers for the depdencies.
# Make a table by adding columns before "notes".

qualifier notes

=G the null qualifier matrix

end_qualifier_ list

| get an obscure bash message telling me that it is expecting more information somehow. If | comment those lines out then | get a
different message which is probably generated by cet build tools telling me it can't do the setup because it can't determine the
qualifier.

| was able to finally get a temporary workaround by creating an artificial dependence on another package (| picked larbatch which
seems harmless enough)... so changing the above lines to

# We now define allowed qualifiers and the corresponding qualifiers for the depdencies.
# Make a table by adding columns before "notes".

qualifier larbatch notes

=G =G} the null qualifier matrix

end_qualifier_list

allows mrbsetenv to be happy and | can proceed with the build.

History

#1 - 04/12/2019 12:14 PM - Lynn Garren

- Status changed from New to Feedback

mrb 3 is stricter about matching products and qualifiers. This is meant to be a good thing. Are you building icarus_data along with icaruscode or by
itself? What packages are in your SMRB_SOURCE directory? We need to be able to reproduce the problem.

One workaround is to explicitly setup mrb v2 until we finish investigating.

#2 - 04/15/2019 10:33 AM - Kyle Knoepfel

- Description updated

#3 - 04/15/2019 10:33 AM - Kyle Knoepfel
- Assignee set to Lynn Garren

- Status changed from Feedback to Assigned

#4 - 04/15/2019 05:33 PM - Lynn Garren

- Assignee deleted (Lynn Garren)

This is interesting. Within a few minor cleanups, the structure of icarus_data is the same as the structure of larutils. The difference is that icaruscode
depends on icarus_data. When building the larsoft product suite, there is no product that depends on larutils and we have no problems with
mrbsetenv.

This problem can be reproduced with the instructions below. | have provided a feature branch that reproduces the original problem. It also contains a
few minor cleanups.

make a new mrb working directory

cd $SMRB_SOURCE

mrb g icaruscode

mrb g icarusutils

mrb g icarus_data

cd icarus_data

git checkout feature/team_investigate_22368
cd $SMRB_BUILDDIR

(mrb z if necessary)

mrbsetenv

#5 - 04/15/2019 05:40 PM - Lynn Garren

| should have noted that this problem is not limited to macOS. It is also reproducible on SLF7.

#6 - 04/16/2019 05:31 PM - Christopher Green
- % Done changed from 0 to 100
- Assignee set to Christopher Green

- Status changed from Assigned to Resolved

This problem is resolved with mrb:69b01a8 for mrb v3_01_02.

Despite the workaround being to change the icarus_data ups/product_deps file, the actual problem was with the way mrb v3 was reading the
icaruscode ups/product_deps file, which listed icarus_data as a dependency.

One of the changes that came with mrb 3 was the ability to specify -ng- in the third column of a non-only_for_build dependency's product/version
table and omit the column from the qualifier matrix table entirely: the table_format should be specified on the product/version table's header line thus:

product version <table_format=2>

Unfortunately, when the unqualified dependency was part of the mrb development set, the mrb 2 way of specifying an unqualified non-only_for_build
dependency was broken (if the dependency was found as an installed UPS product everything worked).

So, your choices are:
1. Use mrb 2.
2.Use mrb 3 >=v3 01_02.

3. Change the icaruscode ups/product_deps file as described above and use mrb 3.

Note that in all three of your alternatives above, the existing workaround of having an otherwise-unnecessary qualifier table in icarus_data's
ups/product_deps file is unnecessary and may be removed.

#7 - 04/17/2019 11:12 AM - Lynn Garren
- % Done changed from 100 to 0
- Assignee deleted (Christopher Green)

mrb v3_01_02 is now installed on cvmfs.

#8 - 04/17/2019 11:12 AM - Lynn Garren
- % Done changed from 0 to 100

#9 - 04/22/2019 10:35 AM - Kyle Knoepfel

- Status changed from Resolved to Closed
